using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            FileRead();
            ListBoxFill();
        }

        void FileRead()
        {
            string path = @"C:\Users\szabomarton\Desktop\C#\ProgaOra\20240603\WindowsFormsApp1\WindowsFormsApp1\bin\Debug\szeptember.csv";
            FileStream fileStream = new FileStream(path, FileMode.Open, FileAccess.Read);
            StreamReader streamReader = new StreamReader(fileStream);

            string line = streamReader.ReadLine();
            Data.header = line.Split(';');
            line = streamReader.ReadLine();
            while (line != null)
            {
                string[] datas = line.Split(';');
                int elso = Convert.ToInt32(datas[2]);
                int utolso = Convert.ToInt32(datas[3]);
                int mulasztott = Convert.ToInt32(datas[4]);

                Tanulo diak = new Tanulo(datas[0], datas[1], elso, utolso, mulasztott);
                Data.tanulok.Add(diak);
                line = streamReader.ReadLine();
            }

            streamReader.Close();
            fileStream.Close();
        }

        void ListBoxFill()
        {
            string header = $"{Data.header[0]}\t\t{Data.header[1]}\t{Data.header[2]}\t{Data.header[3]}\t{Data.header[4]}";
            listBox1.Items.Add(header);
            foreach (var item in Data.tanulok)
            {
                string pattern = $"{item.nev}\t{item.osztaly}\t{item.elso}\t{item.utolso}\t\t{item.mulasztott}";
                listBox1.Items.Add(pattern);
            }
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (IsNotEmpty())
            {
                int elso, utolso, mulasztas;
                if (int.TryParse(textBox3.Text, out elso) && int.TryParse(textBox4.Text, out utolso) && int.TryParse(textBox5.Text, out mulasztas))
                {
                    if (elso > 0 && utolso < 32 && utolso > 0 && elso < 32 && utolso > elso)
                    {
                        Tanulo diak = new Tanulo(textBox1.Text, textBox2.Text, elso, utolso, mulasztas);
                        Data.tanulok.Add(diak);

                        string path = @"C:\Users\szabomarton\Desktop\C#\ProgaOra\20240603\WindowsFormsApp1\WindowsFormsApp1\bin\Debug\szeptember.csv";
                        string addedline = $"{diak.nev};{diak.osztaly};{diak.elso};{diak.utolso};{diak.mulasztott}";
                        using (StreamWriter streamWriter = File.AppendText(path))
                        {
                            streamWriter.WriteLine(addedline);
                        }


                        MessageBox.Show("Az adatot sikeresen rögzítettük.");
                    }
                    else
                    {
                        MessageBox.Show("Az utolsó nap nagyobb legyen mint az első!");
                    }
                    
                }
                else
                {
                    MessageBox.Show("Hiba. Kérem a mezőkbe a megfelelő adatot szolgáltasson!");
                }
            }
            else
            {
                MessageBox.Show("Hiba. Valamelyik mezőt nem töltötte ki.");
            }
        }

        bool IsNotEmpty()
        {
            if (textBox1.Text != "" && textBox2.Text != "" && textBox3.Text != "" && textBox4.Text != "" && textBox5.Text != "")
            {
                return true;
            }
            return false;
        }
    }

    public static class Data
    {
        public static List<Tanulo> tanulok = new List<Tanulo>();
        public static string[] header;
    }

    public class Tanulo
    {
        public string nev;
        public string osztaly;
        public int elso;
        public int utolso;
        public int mulasztott;

        public Tanulo(string nev, string osztaly, int elso, int utolso, int mulasztott)
        {
            this.nev = nev;
            this.osztaly = osztaly;
            this.elso = elso;
            this.utolso = utolso;
            this.mulasztott = mulasztott;
        }
    }
}
